;###################################################;
;													;
; Bibliothque iniFile v0.1							;
; Gestion des fichiers .ini							;
; Ecrit par Julien COIGNET							;
;													;
;###################################################;

;###################;
;					;
; Version francaise ;
;					;
;###################;


; Fonction de cration du fichier
;----------------------------------
Function iniCreerFichier(id$)

	; Cration du fichier
	fileout = WriteFile(Upper(id)) 
	; Close the file 
	CloseFile(fileout) 

End Function

; Fonction de cration d'une section
;--------------------------------------
Function iniCreerSection(idFile$, idSection$)

Local SectionExiste = False
Local Ligne$
Local Compteur% = 1

	; Si le fichier n'existe pas, on le cre, et on ecrit le nom de la section
	If FileType(Upper(idFile)) = 0 Then 
		iniCreerFichier(Upper(idFile))
		fileout = OpenFile(Upper(idFile))
		WriteLine(fileout, "[" + Upper(idSection) + "]")
		CloseFile(fileout)
;		Return True
	Else 
		; Si le fichier existe, on le lit
		If FileType(Upper(idFile)) = 1 Then
			fileout = OpenFile(Upper(idFile))
			While Not Eof(fileout)
				Compteur = Compteur + 1
				Ligne = ReadLine(fileout)
				
				If  (Ligne = "[" + Upper(idSection) + "]") Then
					SectionExiste = True
				End If
				
			Wend 
			; Si la section n'y est pas, on l'y insre
			If SectionExiste = False Then
				WriteLine(fileout, "")
				WriteLine(fileout, "[" + Upper(idSection) + "]")
;				Return True
;			Else
;				Return False
			End If
			CloseFile(fileout)
		End If 
	End If	
	
End Function

; Fonction qui dtermine si une ligne reprsente une section
Function iniEstUneSection(Chaine$)
	If (Left(Chaine, 1) = "[") And (Right(Chaine, 1) = "]") Then
		Return True
	Else
		Return False
	End If
End Function

; Fonction qui dtermine si une section existe
Function iniSectionExiste(idFile$, idSection$)

Local Resultat = False
Local Ligne$

	filein = OpenFile(idFile)

	While (Not Eof(filein)) And Resultat = False
		Ligne = ReadLine(filein)
		If Ligne = ("[" + Upper(idSection) + "]") Then
			Resultat = True
		End If
	Wend
	
	CloseFile(filein)
	
	Return Resultat

End Function

; Fonction qui renvoie le nom de la section (sans les crochets)
Function iniNomSection$(Chaine$)

Local Resultat$

	Return Left(Right(Chaine, Len(Chaine ) - 1), Len(Chaine) - 2)

End Function

; Fonction qui crit une variable de type Float dans une section
Function iniCreerVariableFloat(idFile$, idSection$, idVar$, valVar#)

Local Ligne$
Local SectionExiste = False

	; Si le fichier n'existe pas, on le cre, et on ecrit le nom de la section
	If FileType(Upper(idFile)) = 0 Then
		iniCreerSection(idFile, idSection)
		fileout = OpenFile(Upper(idFile))
		While Not Eof(fileout)
			Ligne = ReadLine(fileout)
		Wend
		WriteLine(fileout, idVar + " = " + valVar)
		CloseFile(fileout)
	Else 
		; Si le fichier existe, on le lit
		If FileType(Upper(idFile)) = 1 Then
			fileout = OpenFile(Upper(idFile))
			Ligne = ReadLine(fileout)
			While (Not(Eof(fileout))) ;Or (Ligne = ("[" + Upper(idSection) + "]")))
				Ligne = ReadLine(fileout)
			Wend

			WriteLine(fileout, idVar + " = " + valVar)

			CloseFile(fileout)
		End If
	End If
	
End Function

; Fonction qui crit une variable de type Integer dans une section
Function iniCreerVariableInt(idFile$, idSection$, idVar$, valVar%)

Local Ligne$
Local SectionExiste = False

	; Si le fichier n'existe pas, on le cre, et on ecrit le nom de la section
	If FileType(Upper(idFile)) = 0 Then
		iniCreerSection(idFile, idSection)
		fileout = OpenFile(Upper(idFile))
		While Not Eof(fileout)
			Ligne = ReadLine(fileout)
		Wend
		WriteLine(fileout, idVar + " = " + valVar)
		CloseFile(fileout)
	Else 
		; Si le fichier existe, on le lit
		If FileType(Upper(idFile)) = 1 Then
			fileout = OpenFile(Upper(idFile))
			Ligne = ReadLine(fileout)
			While (Not(Eof(fileout))) ;Or (Ligne = ("[" + Upper(idSection) + "]")))
				Ligne = ReadLine(fileout)
			Wend

			WriteLine(fileout, idVar + " = " + valVar)

			CloseFile(fileout)
		End If
	End If
	
End Function

; Fonction qui crit une variable de type String dans une section
Function iniCreerVariableStr(idFile$, idSection$, idVar$, valVar$)

Local Ligne$
Local SectionExiste = False

	; Si le fichier n'existe pas, on le cre, et on ecrit le nom de la section
	If FileType(Upper(idFile)) = 0 Then
		iniCreerSection(idFile, idSection)
		fileout = OpenFile(Upper(idFile))
		While Not Eof(fileout)
			Ligne = ReadLine(fileout)
		Wend
		WriteLine(fileout, idVar + " = " + valVar)
		CloseFile(fileout)
	Else 
		; Si le fichier existe, on le lit
		If FileType(Upper(idFile)) = 1 Then
			fileout = OpenFile(Upper(idFile))
			Ligne = ReadLine(fileout)
			While (Not(Eof(fileout))) ;Or (Ligne = ("[" + Upper(idSection) + "]")))
				Ligne = ReadLine(fileout)
			Wend

			WriteLine(fileout, idVar + " = " + valVar)

			CloseFile(fileout)
		End If
	End If
	
End Function

; Fonction qui lit une variable de type Float dans une section
Function iniLireVariableFloat#(idFile$, idSection$, idVar$)

Local Ligne$
Local Resultat#

	filein = ReadFile(Upper(idFile))
	Ligne = ReadLine(filein)
	
	While (Not(Eof(filein))) And (Ligne <> "[" + Upper(idSection) + "]")
		ligne = ReadLine(filein)
	Wend
	
	While (Not(Eof(filein))) And (Left(Ligne, Len(idVar)) <> idVar)
		Ligne = ReadLine(filein)
	Wend

	Resultat = Float(Right(Ligne, (Len(Ligne) - (Len(idVar) + 3))))
	
	CloseFile(filein)
	Return Resultat
	
End Function

; Fonction qui lit une variable de type Integer dans une section
Function iniLireVariableInt%(idFile$, idSection$, idVar$)

Local Ligne$
Local Resultat%

	filein = ReadFile(Upper(idFile))
	Ligne = ReadLine(filein)
	
	While (Not(Eof(filein))) And (Ligne <> "[" + Upper(idSection) + "]")
		ligne = ReadLine(filein)
	Wend
	
	While (Not(Eof(filein))) And (Left(Ligne, Len(idVar)) <> idVar)	
		Ligne = ReadLine(filein)
	Wend
	
	Resultat = Int(Right(Ligne, (Len(Ligne) - (Len(idVar) + 3))))
	
	CloseFile(filein)
	Return Resultat
	
End Function

; Fonction qui lit une variable de Type Sting dans une section
Function iniLireVariableStr$(idFile$, idSection$, idVar$)

Local Ligne$
Local Resultat$
	
	filein = ReadFile(Upper(idFile))
	Ligne = ReadLine(filein)
	
	While (Not(Eof(filein))) And (Ligne <> "[" + Upper(idSection) + "]")
		ligne = ReadLine(filein)
	Wend

	While (Not(Eof(filein))) And (Left(Ligne, Len(idVar)) <> idVar)
		Ligne = ReadLine(filein)
	Wend

	Resultat = Right(Ligne, (Len(Ligne) - (Len(idVar) + 3)))
	
	CloseFile(filein)
	Return Resultat
	
End Function


;###################;
;					;
; Version anglaise	;
;					;
;###################;

Function iniCreateFile(id$)
	iniCreerFichier(id$)
End Function

Function iniCreateSection(idFile$, idSection$)
	iniCreerSection(idFile$, idSection$)
End Function

Function iniIsSection(Chaine$)
	Return(iniEstUneSection(Chaine$))
End Function

Function iniSectionExist(idFile$, idSection$)
	Return(iniSectionExiste(idFile$, idSection$))
End Function

Function iniSectionName$(Chaine$)
	Return(iniNomSection$(Chaine$))
End Function

Function iniCreateVarFloat(idFile$, idSection$, idVar$, valVar#)
	iniCreerVariableFloat(idFile$, idSection$, idVar$, valVar#)
End Function

Function iniCreateVarInt(idFile$, idSection$, idVar$, valVar%)
	iniCreerVariableInt(idFile$, idSection$, idVar$, valVar%)
End Function

Function iniCreateVarStr(idFile$, idSection$, idVar$, valVar$)
	iniCreerVariableStr(idFile$, idSection$, idVar$, valVar$)
End Function

Function iniGetVarFloat#(idFile$, idSection$, idVar$)
	Return(iniLireVariableFloat#(idFile$, idSection$, idVar$))
End Function

Function iniGetVarInt%(idFile$, idSection$, idVar$)
	Return(iniLireVariableInt%(idFile$, idSection$, idVar$))
End Function

Function iniGetVarStr$(idFile$, idSection$, idVar$)
	Return(iniLireVariableStr$(idFile$, idSection$, idVar$))
End Function


